/* =============================================================================================
   Scrolling Stars - (c)1998-1999 Romain Guy 14:41:36 10/04/99
   =============================================================================================
*/

import java.awt.Event;
import java.awt.Color;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.MediaTracker;

public class Stars extends java.applet.Applet implements Runnable
{
  // ---- Cration des objets et variables ----

  // ---- Les toiles ----
  StarField stars;
  int nb, direction, color1, color2, color3;

  // ---- Le Double Buffering ----
  Thread runner;
  Graphics off;
  Image offImg;
  MediaTracker tracker;

  // ---- L'image titre ----
  Image title;
  boolean display = true;

  // ---- Largeur et hauteur de l'applet ----
  int width, height;

  public void init()
  {
    // ---- On stocke les largeurs et heuteurs ----
    width = size().width;
    height = size().height;

    // ---- Double Buffering initialis ----
    setBackground(Color.black);
    offImg = createImage(width, height);
    off = offImg.getGraphics();

    // ---- On initialise l'image titre ----
    String titleSource = getParameter("img");
    if (titleSource != null)
      title = getImage(getCodeBase(), titleSource);
    else
      display = false;
    try
    {
      tracker = new MediaTracker(this);
      tracker.addImage(title, 0);
      tracker.waitForID(0);
    } catch (InterruptedException e) { }

    // ---- Initialisation des toiles ----

    String nbStars = getParameter("nb");
    if (nbStars == null)
      nb = 50;
    else
    { try { nb = Integer.parseInt(nbStars); }
      catch (Throwable t) { nb = 50; }
    }

    String col1 = getParameter("color1");
    if (col1 == null)
      color1 = 123;
    else
    { try { color1 = Integer.parseInt(col1); if ((color1 > 255) || (color1 < 0)) color1 = 123; }
      catch (Throwable t) { color1 = 123; }
    }

    String col2 = getParameter("color2");
    if (col2 == null)
      color2 = 145;
    else
    { try { color2 = Integer.parseInt(col2); if ((color2 > 255) || (color2 < 0)) color2 = 145; }
      catch (Throwable t) { color2 = 145; }
    }

    String col3 = getParameter("color3");
    if (col3 == null)
      color3 = 165;
    else
    { try { color3 = Integer.parseInt(col3); if ((color3 > 255) || (color3 < 0)) color2 = 165; }
      catch (Throwable t) { color3 = 165; }
    }

    int[] colors = { color1, color2, color3 };

    String dir = getParameter("direction");
    if (dir == null)
      direction = stars.VERTICAL;
    else
      if (dir.equals("horizontal"))
        direction = stars.HORIZONTAL;
      else
        direction = stars.VERTICAL;

    // ---- Les toiles ----
    int[] moves = { 3, 2, 1 };
    stars = new StarField(colors, moves, nb, direction, width, height);
  }

  public void start()
  {
    // ---- Lancement des Threads ----
    if (runner == null)
    {
      runner = new Thread(this);
      runner.start();
    }
  }

  public void stop()
  {
    runner = null;
  }

  public void run()
  {
    while (runner != null)
      repaint();
  }

  public void repaint()
  {
    update(getGraphics());
    paint(getGraphics());
  }

  public void update(Graphics g)
  {
    // ---- On efface le Graphics off ----
    off.setColor(Color.black);
    off.fillRect(0, 0, width, height);
  }

  public void paint(Graphics g)
  {
    // ---- Si les toiles sont prtes, les dessiner ----
    if (!stars.isDrawing()) stars.paint(off);
    // ---- On affiche l'image titre ----
    if (display) off.drawImage(title, (width - title.getWidth(this)) / 2, (height - title.getHeight(this)) / 2, this);
    // ---- On affiche le buffer ----
    g.drawImage(offImg, 0, 0, this);
  }

  // ---- Infos ----

  public boolean mouseEnter(Event evt, int x, int y)
  {
    getAppletContext().showStatus("Stars (c)1998 Romain Guy");
    return true;
  }

  public boolean mouseExit(Event evt, int x, int y)
  {
    getAppletContext().showStatus("Stars (c)1998 Romain Guy");
    return true;
  }
}

// Fin du source
